#ifndef __EINA_CONFIG_H__
#define __EINA_CONFIG_H__

#include <glib.h>
#include <glib-object.h>

typedef struct _EinaConfig EinaConfig;

EinaConfig *eina_config_new (void);
void eina_config_free (EinaConfig *cfg);

gint eina_config_notify_add(EinaConfig *cfg, gpointer callback, gpointer data);
void eina_config_notify_remove(EinaConfig *cfg, gint id);

void eina_config_set        (EinaConfig *cfg, gchar *key, GValue *val);
void eina_config_set_bool   (EinaConfig *cfg, gchar *key, gboolean val);
void eina_config_set_int    (EinaConfig *cfg, gchar *key, gint val);
void eina_config_set_float  (EinaConfig *cfg, gchar *key, gfloat val);
void eina_config_set_string (EinaConfig *cfg, gchar *key, gchar *val);

GValue *eina_config_get              (EinaConfig *cfg, gchar *key);
gint eina_config_get_int             (EinaConfig *cfg, gchar *key, gint def);
gfloat eina_config_get_float         (EinaConfig *cfg, gchar *key, gfloat def);
gboolean eina_config_get_bool        (EinaConfig *cfg, gchar *key, gboolean def);
const gchar * eina_config_get_string (EinaConfig *cfg, gchar *key, gchar *def);

GType eina_config_get_type(EinaConfig *cfg, gchar *key);
const gchar *eina_config_get_type_name(EinaConfig *cfg, gchar *key);

#endif

