#ifndef __LIBEINA_METADATA_H__
#define __LIBEINA_METADATA_H__
#include <glib.h>
#include <libeina/stream.h>

G_BEGIN_DECLS

typedef struct _EinaMetadataEngine EinaMetadataEngine;

/*
 * @eina_metadata_engine_new
 * @Creates a new parse for metadata who reads files with 'src' plugin
 *  gchar* src: gst plugin used to read files
 *  EinaMetadataEngine* ret: The new metadata parse
 */
EinaMetadataEngine *eina_metadata_engine_new(gchar *src);

/*
 * @eina_metadata_engine_unref
 * @Deletes a metadata parser
 *  EinaMetadataEngine* self: [self]
 */
void eina_metadata_engine_unref(EinaMetadataEngine *self);

/*
 * @eina_metadata_engine_parse
 * @Parses an EinaStream, extracts metadata and saves it into the stream using his methods
 *  EinaMetadataEngine* self: [self]
 *  EinaStream* stream: The stream to parse
 *  gboolean ret: TRUE on successful operation, FALSE otherwise
 */
gboolean eina_metadata_engine_parse(EinaMetadataEngine *self, EinaStream *stream);

G_END_DECLS

#endif /* __LIBEINA_METADATA_H__ */

