#ifndef __LIBEINA_PRIV_H__
#define __LIBEINA_PRIV_H__

G_BEGIN_DECLS

#include <libeina/core.h>
#include <libeina/playlist.h>
#include <libeina/metadata.h>
#include <magic.h>

typedef struct EinaPlayerFade {
	gint        orig_volume;   /* [0,100] */
	gint64      orig_position; /* gint64  */
	gint64      length;
} EinaPlayerFade;

struct _EinaPlayer {
    GList *slots;

	gchar *src, *sink;
	
    EinaPlaylist *pl;
    EinaCore *core, *core_aux;
	EinaMetadataEngine *metadata_engine;

	magic_t mimedetector;
	
    EinaState state;
    
	guint watcher_id;
	guint fadeout_id;
    gint eos;
	
	EinaPlayerFade *fadeout;

	/* For eina IPC */
    GIOChannel *channel;
    gboolean master;
};

gboolean eina_player_eos_watcher (gpointer data);
guint eina_player_start_fadeout(EinaPlayer *p, gint64 length);
void  eina_player_stop_fadeout (EinaPlayer *p);
guint eina_player_start_fadein (EinaPlayer *p, gint64 length);
void  eina_player_stop_fadein  (EinaPlayer *p);

gboolean eina_player_fade_out(gpointer data);

void _eina_player_emit_signal(EinaPlayer *p, EinaSignal signal, gpointer data1, gpointer data2);
void eina_player_trap_eos(gpointer data1, gpointer data2);
const gchar *eina_priv_get_mime(EinaPlayer *p, const gchar *filename);

G_END_DECLS

#endif

