#ifndef __ELIB_TAG_H__
#define __ELIB_TAG_H__
#include <glib.h>
#include <glib-object.h>

typedef enum EinaTag {
	/* Gstreamer tags */
	EINA_TAG_INVALID,
	EINA_TAG_TITLE,
	EINA_TAG_ARTIST,
	EINA_TAG_ALBUM,
	EINA_TAG_DATE,
	EINA_TAG_GENRE,
	EINA_TAG_COMMENT,
	EINA_TAG_TRACK_NUMBER,
	EINA_TAG_TRACK_COUNT,
	EINA_TAG_ALBUM_VOLUME_NUMBER,
	EINA_TAG_ALBUM_VOLUME_COUNT,
	EINA_TAG_LOCATION,
	EINA_TAG_DESCRIPTION,
	EINA_TAG_VERSION,
	EINA_TAG_ISRC,
	EINA_TAG_ORGANIZATION,
	EINA_TAG_COPYRIGHT,
	EINA_TAG_CONTACT,
	EINA_TAG_LICENSE,
	EINA_TAG_PERFORMER,
	EINA_TAG_DURATION,
	EINA_TAG_CODEC,
	EINA_TAG_VIDEO_CODEC,
	EINA_TAG_AUDIO_CODEC,
	EINA_TAG_BITRATE,
	EINA_TAG_NOMINAL_BITRATE,
	EINA_TAG_MINIMUM_BITRATE,
	EINA_TAG_MAXIMUM_BITRATE,
	EINA_TAG_SERIAL,
	EINA_TAG_ENCODER,
	EINA_TAG_ENCODER_VERSION,
	EINA_TAG_TRACK_GAIN,
	EINA_TAG_TRACK_PEAK,
	EINA_TAG_ALBUM_GAIN,
	EINA_TAG_ALBUM_PEAK,

	/* Extra tags, libeina specific */
	EINA_TAG_LAYER,
	EINA_TAG_MODE,
	EINA_TAG_EMPHASIS,

	EINA_TAGS
} EinaTag;

GType eina_tag_get_type(EinaTag tag);
EinaTag eina_tag_get_tag_from_string(const gchar *gst_tag) ;
const gchar *eina_tag_get_string_from_tag(EinaTag tag);

#endif

