#include <libeina/tag.h>
#include <gst/gst.h>

typedef struct EinaTagDef {
	EinaTag tag;
	const gchar *name;
	GType type;
} EinaTagDef;

#if 0
	/* :r ! grep EINA_TAG includes/libeina/tag.h */
	G_TYPE_INVALID,// EINA_TAG_INVALID
	G_TYPE_STRING,// EINA_TAG_TITLE,
	G_TYPE_STRING, // EINA_TAG_ARTIST,
	G_TYPE_STRING,// EINA_TAG_ALBUM,
	G_TYPE_INT, // EINA_TAG_DATE,
	G_TYPE_STRING, // EINA_TAG_GENRE,
	G_TYPE_STRING, // EINA_TAG_COMMENT,
	G_TYPE_INT, // EINA_TAG_TRACK_NUMBER,
	G_TYPE_INT, // ? EINA_TAG_TRACK_COUNT,
	G_TYPE_INT, // ? EINA_TAG_ALBUM_VOLUME_NUMBER,
	G_TYPE_INT, // ? EINA_TAG_ALBUM_VOLUME_COUNT,
	G_TYPE_INT, // ? EINA_TAG_LOCATION,
	G_TYPE_STRING, // EINA_TAG_DESCRIPTION,
	G_TYPE_STRING, // EINA_TAG_VERSION,
	G_TYPE_STRING, // EINA_TAG_ISRC,
	G_TYPE_STRING, // EINA_TAG_ORGANIZATION,
	G_TYPE_STRING, // EINA_TAG_COPYRIGHT,
	G_TYPE_STRING, // EINA_TAG_CONTACT,
	G_TYPE_STRING, // EINA_TAG_LICENSE,
	G_TYPE_STRING, // EINA_TAG_PERFORMER,
	G_TYPE_LONG, // EINA_TAG_DURATION,
	G_TYPE_STRING, // EINA_TAG_CODEC,
	G_TYPE_STRING, // EINA_TAG_VIDEO_CODEC,
	G_TYPE_STRING, // EINA_TAG_AUDIO_CODEC,
	G_TYPE_INT, // EINA_TAG_BITRATE,
	G_TYPE_INT, // ? EINA_TAG_NOMINAL_BITRATE,
	G_TYPE_INT, // ? EINA_TAG_MINIMUM_BITRATE,
	G_TYPE_INT, // ? EINA_TAG_MAXIMUM_BITRATE,
	G_TYPE_STRING, // ? EINA_TAG_SERIAL,
	G_TYPE_STRING, // ? EINA_TAG_ENCODER,
	G_TYPE_STRING, // ? EINA_TAG_ENCODER_VERSION,
	G_TYPE_DOUBLE, // EINA_TAG_TRACK_GAIN,
	G_TYPE_DOUBLE, // EINA_TAG_TRACK_PEAK,
	G_TYPE_DOUBLE, // EINA_TAG_ALBUM_GAIN,
	G_TYPE_DOUBLE // EINA_TAG_ALBUM_PEAK,
#endif

static EinaTagDef _eina_tags[EINA_TAGS] = {
	{ EINA_TAG_INVALID,				"invalid",						G_TYPE_INVALID	},
	{ EINA_TAG_TITLE,				GST_TAG_TITLE,					G_TYPE_STRING	},
	{ EINA_TAG_ARTIST,				GST_TAG_ARTIST,					G_TYPE_STRING	},
	{ EINA_TAG_ALBUM,				GST_TAG_ALBUM,					G_TYPE_STRING	},
	{ EINA_TAG_DATE,				GST_TAG_DATE,					G_TYPE_UINT		},
	{ EINA_TAG_GENRE,				GST_TAG_GENRE,					G_TYPE_STRING	}, // XXX
	{ EINA_TAG_COMMENT,				GST_TAG_COMMENT,				G_TYPE_STRING	},
	{ EINA_TAG_TRACK_NUMBER,		GST_TAG_TRACK_NUMBER,			G_TYPE_UINT		},
	{ EINA_TAG_TRACK_COUNT,			GST_TAG_TRACK_COUNT,			G_TYPE_UINT		},
	{ EINA_TAG_ALBUM_VOLUME_NUMBER,	GST_TAG_ALBUM_VOLUME_NUMBER,	G_TYPE_UINT     }, // XXX
	{ EINA_TAG_ALBUM_VOLUME_COUNT,	GST_TAG_ALBUM_VOLUME_COUNT,		G_TYPE_UINT     },
	{ EINA_TAG_LOCATION,			GST_TAG_LOCATION,				G_TYPE_INVALID	},
	{ EINA_TAG_DESCRIPTION,			GST_TAG_DESCRIPTION,			G_TYPE_INVALID	},
	{ EINA_TAG_VERSION,				GST_TAG_VERSION,				G_TYPE_INVALID	},
	{ EINA_TAG_ISRC,				GST_TAG_ISRC,					G_TYPE_INVALID	},
	{ EINA_TAG_ORGANIZATION,		GST_TAG_ORGANIZATION,			G_TYPE_INVALID	},
	{ EINA_TAG_COPYRIGHT,			GST_TAG_COPYRIGHT,				G_TYPE_STRING	},
	{ EINA_TAG_CONTACT,				GST_TAG_CONTACT,				G_TYPE_INVALID	},
	{ EINA_TAG_LICENSE,				GST_TAG_LICENSE,				G_TYPE_INVALID	},
	{ EINA_TAG_PERFORMER,			GST_TAG_PERFORMER,				G_TYPE_INVALID	},
	{ EINA_TAG_DURATION,			GST_TAG_DURATION,				G_TYPE_UINT64	},
	{ EINA_TAG_CODEC,				GST_TAG_CODEC,					G_TYPE_INVALID	},
	{ EINA_TAG_VIDEO_CODEC,			GST_TAG_VIDEO_CODEC,			G_TYPE_INVALID	},
	{ EINA_TAG_AUDIO_CODEC,			GST_TAG_AUDIO_CODEC,			G_TYPE_STRING   },
	{ EINA_TAG_BITRATE,				GST_TAG_BITRATE,				G_TYPE_UINT		},
	{ EINA_TAG_NOMINAL_BITRATE,		GST_TAG_NOMINAL_BITRATE,		G_TYPE_UINT		},
	{ EINA_TAG_MINIMUM_BITRATE,		GST_TAG_MINIMUM_BITRATE,		G_TYPE_UINT		},
	{ EINA_TAG_MAXIMUM_BITRATE,		GST_TAG_MAXIMUM_BITRATE,		G_TYPE_UINT		},
	{ EINA_TAG_SERIAL,				GST_TAG_SERIAL,					G_TYPE_UINT     },
	{ EINA_TAG_ENCODER,				GST_TAG_ENCODER,				G_TYPE_STRING	},
	{ EINA_TAG_ENCODER_VERSION,		GST_TAG_ENCODER_VERSION,		G_TYPE_UINT		},
	{ EINA_TAG_TRACK_GAIN,			GST_TAG_TRACK_GAIN,				G_TYPE_INVALID	},
	{ EINA_TAG_TRACK_PEAK,			GST_TAG_TRACK_PEAK,				G_TYPE_INVALID	},
	{ EINA_TAG_ALBUM_GAIN,			GST_TAG_ALBUM_GAIN,				G_TYPE_INVALID	},
	{ EINA_TAG_ALBUM_PEAK,			GST_TAG_ALBUM_PEAK,				G_TYPE_INVALID	},
			
	/* Eina tags */
	{ EINA_TAG_LAYER,				"layer",						G_TYPE_UINT		},
	{ EINA_TAG_MODE,				"mode",							G_TYPE_STRING	},
	{ EINA_TAG_EMPHASIS,			"emphasis",						G_TYPE_STRING	}
};

/*
 * Retuns type of a tag
 */ 
GType eina_tag_get_type(EinaTag tag) {
	EinaTag aux = 0;
	gboolean found = FALSE;
	GType ret = G_TYPE_INVALID;
	
	while ((aux < EINA_TAGS) && !found) {
		if (_eina_tags[aux].tag == tag) {
			found = TRUE;
			ret = _eina_tags[aux].type;
		} else {
			aux++;
		}
	}

	return ret;
}

/*
 * Converts a string to an EinaTag type
 */
EinaTag eina_tag_get_tag_from_string(const gchar *string) {
	EinaTag aux = 0;
	gboolean found = FALSE;
	EinaTag ret = EINA_TAG_INVALID;

	while ((aux < EINA_TAGS) && !found) {
		if ( g_str_equal(_eina_tags[aux].name, string) ) {
			ret = aux;
			found = TRUE;
		} else {
			aux++;
		}
	}

	return ret;
}

const gchar *eina_tag_get_string_from_tag(EinaTag tag) {
	const gchar *ret = NULL;
	gboolean found = FALSE;
	EinaTag aux = 0;
	
	while ((aux < EINA_TAGS) && !found) {
		if ( _eina_tags[aux].tag == tag ) {
			found = TRUE;
			ret = _eina_tags[aux].name;
		} else {
			aux++;
		}
	}
	
	return ret;
}

